﻿// <auto-generated />
using System;
using System.Collections.Generic;
using AttendancePlus.AdminApi.Data;
using AttendancePlus.AdminApi.Data.Model;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using NetTopologySuite.Geometries;
using NodaTime;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;

#nullable disable

namespace AttendancePlus.AdminApi.Migrations
{
    [DbContext(typeof(AdministrationDbContext))]
    partial class AdministrationDbContextModelSnapshot : ModelSnapshot
    {
        protected override void BuildModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "6.0.9")
                .HasAnnotation("Relational:MaxIdentifierLength", 63);

            NpgsqlModelBuilderExtensions.HasPostgresEnum(modelBuilder, "relation", new[] { "father", "mother", "others" });
            NpgsqlModelBuilderExtensions.HasPostgresEnum(modelBuilder, "role", new[] { "school_admin", "campus_admin", "homeroom_supervisor", "bus_supervisor", "bus_device", "homeroom_device", "parent", "user", "super_admin" });
            NpgsqlModelBuilderExtensions.HasPostgresExtension(modelBuilder, "postgis");
            NpgsqlModelBuilderExtensions.UseIdentityByDefaultColumns(modelBuilder);

            modelBuilder.Entity("AttendancePlus.AdminApi.Data.Model.Bus", b =>
                {
                    b.Property<string>("Id")
                        .HasMaxLength(32)
                        .HasColumnType("character varying(32)");

                    b.Property<string>("CampusId")
                        .IsRequired()
                        .HasColumnType("character varying(32)");

                    b.Property<ZonedDateTime>("CreatedOn")
                        .HasColumnType("timestamp with time zone");

                    b.Property<ISet<Name>>("Names")
                        .IsRequired()
                        .HasColumnType("jsonb");

                    b.Property<ZonedDateTime?>("UpdatedOn")
                        .HasColumnType("timestamp with time zone");

                    b.Property<uint>("xmin")
                        .IsConcurrencyToken()
                        .ValueGeneratedOnAddOrUpdate()
                        .HasColumnType("xid");

                    b.HasKey("Id");

                    b.HasIndex("CampusId");

                    b.HasIndex("Names");

                    NpgsqlIndexBuilderExtensions.HasMethod(b.HasIndex("Names"), "gin");
                    NpgsqlIndexBuilderExtensions.HasOperators(b.HasIndex("Names"), new[] { "jsonb_ops" });

                    b.ToTable("Bus");
                });

            modelBuilder.Entity("AttendancePlus.AdminApi.Data.Model.Campus", b =>
                {
                    b.Property<string>("Id")
                        .HasMaxLength(32)
                        .HasColumnType("character varying(32)");

                    b.Property<ZonedDateTime>("CreatedOn")
                        .HasColumnType("timestamp with time zone");

                    b.Property<Point>("Location")
                        .IsRequired()
                        .HasColumnType("geometry (point)");

                    b.Property<ISet<Name>>("Names")
                        .IsRequired()
                        .HasColumnType("jsonb");

                    b.Property<string>("SchoolId")
                        .IsRequired()
                        .HasColumnType("character varying(32)");

                    b.Property<ZonedDateTime?>("UpdatedOn")
                        .HasColumnType("timestamp with time zone");

                    b.Property<uint>("xmin")
                        .IsConcurrencyToken()
                        .ValueGeneratedOnAddOrUpdate()
                        .HasColumnType("xid");

                    b.HasKey("Id");

                    b.HasIndex("Names");

                    NpgsqlIndexBuilderExtensions.HasMethod(b.HasIndex("Names"), "gin");
                    NpgsqlIndexBuilderExtensions.HasOperators(b.HasIndex("Names"), new[] { "jsonb_ops" });

                    b.HasIndex("SchoolId");

                    b.ToTable("Campus");
                });

            modelBuilder.Entity("AttendancePlus.AdminApi.Data.Model.School", b =>
                {
                    b.Property<string>("Id")
                        .HasMaxLength(32)
                        .HasColumnType("character varying(32)");

                    b.Property<ZonedDateTime>("CreatedOn")
                        .HasColumnType("timestamp with time zone");

                    b.Property<ISet<Name>>("Names")
                        .IsRequired()
                        .HasColumnType("jsonb");

                    b.Property<ZonedDateTime?>("UpdatedOn")
                        .HasColumnType("timestamp with time zone");

                    b.Property<uint>("xmin")
                        .IsConcurrencyToken()
                        .ValueGeneratedOnAddOrUpdate()
                        .HasColumnType("xid");

                    b.HasKey("Id");

                    b.HasIndex("Names");

                    NpgsqlIndexBuilderExtensions.HasMethod(b.HasIndex("Names"), "gin");
                    NpgsqlIndexBuilderExtensions.HasOperators(b.HasIndex("Names"), new[] { "jsonb_ops" });

                    b.ToTable("School");
                });

            modelBuilder.Entity("AttendancePlus.AdminApi.Data.Model.Student", b =>
                {
                    b.Property<string>("Id")
                        .HasMaxLength(32)
                        .HasColumnType("character varying(32)");

                    b.Property<string>("BusId")
                        .IsRequired()
                        .HasColumnType("character varying(32)");

                    b.Property<ZonedDateTime>("CreatedOn")
                        .HasColumnType("timestamp with time zone");

                    b.Property<Point>("Location")
                        .IsRequired()
                        .HasColumnType("geometry (point)");

                    b.Property<ISet<Name>>("Names")
                        .IsRequired()
                        .HasColumnType("jsonb");

                    b.Property<ISet<ParentDetails>>("Parents")
                        .IsRequired()
                        .HasColumnType("jsonb");

                    b.Property<ZonedDateTime?>("UpdatedOn")
                        .HasColumnType("timestamp with time zone");

                    b.Property<uint>("xmin")
                        .IsConcurrencyToken()
                        .ValueGeneratedOnAddOrUpdate()
                        .HasColumnType("xid");

                    b.HasKey("Id");

                    b.HasIndex("BusId");

                    b.HasIndex("Names");

                    NpgsqlIndexBuilderExtensions.HasMethod(b.HasIndex("Names"), "gin");
                    NpgsqlIndexBuilderExtensions.HasOperators(b.HasIndex("Names"), new[] { "jsonb_ops" });

                    b.HasIndex("Parents");

                    NpgsqlIndexBuilderExtensions.HasMethod(b.HasIndex("Parents"), "gin");
                    NpgsqlIndexBuilderExtensions.HasOperators(b.HasIndex("Parents"), new[] { "jsonb_ops" });

                    b.ToTable("Student");
                });

            modelBuilder.Entity("AttendancePlus.AdminApi.Data.Model.User", b =>
                {
                    b.Property<string>("Id")
                        .HasMaxLength(32)
                        .HasColumnType("character varying(32)");

                    b.Property<ZonedDateTime>("CreatedOn")
                        .HasColumnType("timestamp with time zone");

                    b.Property<string>("Email")
                        .HasMaxLength(256)
                        .HasColumnType("character varying(256)");

                    b.Property<DateTimeOffset?>("EmailConfirmed")
                        .HasColumnType("timestamp with time zone");

                    b.Property<string>("MobileNumber")
                        .HasMaxLength(15)
                        .HasColumnType("character varying(15)");

                    b.Property<DateTimeOffset?>("MobileNumberConfirmed")
                        .HasColumnType("timestamp with time zone");

                    b.Property<ISet<Name>>("Names")
                        .IsRequired()
                        .HasColumnType("jsonb");

                    b.Property<Role>("Role")
                        .HasColumnType("role");

                    b.Property<ZonedDateTime?>("UpdatedOn")
                        .HasColumnType("timestamp with time zone");

                    b.Property<string>("UserKey")
                        .IsRequired()
                        .HasMaxLength(32)
                        .HasColumnType("character varying(32)");

                    b.Property<uint>("xmin")
                        .IsConcurrencyToken()
                        .ValueGeneratedOnAddOrUpdate()
                        .HasColumnType("xid");

                    b.HasKey("Id");

                    b.HasIndex("Email")
                        .IsUnique();

                    NpgsqlIndexBuilderExtensions.HasOperators(b.HasIndex("Email"), new[] { "varchar_pattern_ops" });

                    b.HasIndex("MobileNumber")
                        .IsUnique();

                    NpgsqlIndexBuilderExtensions.HasOperators(b.HasIndex("MobileNumber"), new[] { "varchar_pattern_ops" });

                    b.HasIndex("Names");

                    NpgsqlIndexBuilderExtensions.HasMethod(b.HasIndex("Names"), "gin");
                    NpgsqlIndexBuilderExtensions.HasOperators(b.HasIndex("Names"), new[] { "jsonb_ops" });

                    b.ToTable("User");
                });

            modelBuilder.Entity("AttendancePlus.AdminApi.Data.Model.UserClaim", b =>
                {
                    b.Property<string>("Id")
                        .HasMaxLength(32)
                        .HasColumnType("character varying(32)");

                    b.Property<ZonedDateTime>("CreatedOn")
                        .HasColumnType("timestamp with time zone");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<ZonedDateTime?>("UpdatedOn")
                        .HasColumnType("timestamp with time zone");

                    b.Property<string>("UserId")
                        .IsRequired()
                        .HasColumnType("character varying(32)");

                    b.Property<string>("Value")
                        .IsRequired()
                        .HasMaxLength(255)
                        .HasColumnType("character varying(255)");

                    b.Property<uint>("xmin")
                        .IsConcurrencyToken()
                        .ValueGeneratedOnAddOrUpdate()
                        .HasColumnType("xid");

                    b.HasKey("Id");

                    b.HasIndex("Name");

                    NpgsqlIndexBuilderExtensions.HasOperators(b.HasIndex("Name"), new[] { "varchar_pattern_ops" });

                    b.HasIndex("UserId");

                    b.ToTable("UserClaim");
                });

            modelBuilder.Entity("AttendancePlus.AdminApi.Data.Model.Bus", b =>
                {
                    b.HasOne("AttendancePlus.AdminApi.Data.Model.Campus", "Campus")
                        .WithMany("Buses")
                        .HasForeignKey("CampusId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Campus");
                });

            modelBuilder.Entity("AttendancePlus.AdminApi.Data.Model.Campus", b =>
                {
                    b.HasOne("AttendancePlus.AdminApi.Data.Model.School", "School")
                        .WithMany("Campuses")
                        .HasForeignKey("SchoolId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("School");
                });

            modelBuilder.Entity("AttendancePlus.AdminApi.Data.Model.Student", b =>
                {
                    b.HasOne("AttendancePlus.AdminApi.Data.Model.Bus", "Bus")
                        .WithMany("Students")
                        .HasForeignKey("BusId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Bus");
                });

            modelBuilder.Entity("AttendancePlus.AdminApi.Data.Model.UserClaim", b =>
                {
                    b.HasOne("AttendancePlus.AdminApi.Data.Model.User", "User")
                        .WithMany("Claims")
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("User");
                });

            modelBuilder.Entity("AttendancePlus.AdminApi.Data.Model.Bus", b =>
                {
                    b.Navigation("Students");
                });

            modelBuilder.Entity("AttendancePlus.AdminApi.Data.Model.Campus", b =>
                {
                    b.Navigation("Buses");
                });

            modelBuilder.Entity("AttendancePlus.AdminApi.Data.Model.School", b =>
                {
                    b.Navigation("Campuses");
                });

            modelBuilder.Entity("AttendancePlus.AdminApi.Data.Model.User", b =>
                {
                    b.Navigation("Claims");
                });
#pragma warning restore 612, 618
        }
    }
}
